--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/usb.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/usb.c	2015-04-29 14:37:06.741752000 +0800
@@ -0,0 +1,110 @@
+#include <linux/kernel.h>
+#include <linux/utsname.h>
+#include <linux/slab.h>
+#include <linux/uaccess.h>
+#include <linux/platform_device.h>
+#include <linux/dma-mapping.h>
+
+#include <linux/usb/ohci_pdriver.h>
+#include <linux/usb/ehci_pdriver.h>
+#include <linux/usb/g_hid.h>
+
+#include <mach/hardware.h>
+#include <mach/irqs.h>
+
+#include <linux/export.h>
+#include <mach/usb.h>
+#include <linux/kobject.h>
+
+static u64 dmamask = DMA_BIT_MASK(32);
+
+static struct resource ehci_resources[] = {
+	{
+		.start = CNC1900_USB_EHCI,
+		.end   = CNC1900_USB_EHCI + SZ_4K - 1,
+		.flags = IORESOURCE_MEM,
+	}, {
+		.start = EHCI_IRQ,
+		.flags = IORESOURCE_IRQ,
+	},
+};
+
+static struct usb_ehci_pdata pdata_ehci = {
+	.caps_offset = 0x100,
+};
+
+static struct platform_device dev_ehci = {
+	.name = "ehci-platform",
+	.id   = -1,
+	.dev  = {
+		.dma_mask = &dmamask,
+		.coherent_dma_mask = DMA_BIT_MASK(32),
+		.platform_data = &pdata_ehci,
+	},
+	.resource = ehci_resources,
+	.num_resources = ARRAY_SIZE(ehci_resources),
+};
+
+static struct resource ohci_resources[] = {
+	{
+		.start = CNC1900_USB_OHCI,
+		.end   = CNC1900_USB_OHCI + SZ_4K - 1,
+		.flags = IORESOURCE_MEM,
+	}, {
+		.start = OHCI_IRQ,
+		.flags = IORESOURCE_IRQ,
+	},
+};
+
+static struct usb_ehci_pdata pdata_ohci = {
+};
+
+static struct platform_device dev_ohci = {
+	.name = "ohci-platform",
+	.id   = -1,
+	.dev  = {
+		.dma_mask = &dmamask,
+		.coherent_dma_mask = DMA_BIT_MASK(32),
+		.platform_data = &pdata_ohci,
+	},
+	.resource = ohci_resources,
+	.num_resources = ARRAY_SIZE(ohci_resources),
+};
+
+static struct resource otg_resources[] = {
+	{
+		.start = CNC1900_USB_OTG,
+		.end   = CNC1900_USB_OTG + SZ_256K - 1,
+		.flags = IORESOURCE_MEM,
+	}, {
+		.start = OTG_IRQ,
+		.flags = IORESOURCE_IRQ,
+	},
+};
+
+static struct platform_device dev_otg = {
+	.name = "dwc_otg",
+	.id   = -1,
+	.dev  = {
+		.dma_mask = &dmamask,
+		.coherent_dma_mask = DMA_BIT_MASK(32),
+	},
+	.resource = otg_resources,
+	.num_resources = ARRAY_SIZE(otg_resources),
+};
+
+static struct platform_device *devices[] __initdata = {
+#ifdef CONFIG_CELESTIAL_HCI
+	&dev_ehci,
+	&dev_ohci,
+#endif
+#ifdef CONFIG_CELESTIAL_OTG
+	&dev_otg,
+#endif
+};
+
+int __init platform_add_usbs()
+{
+	platform_add_devices(devices, ARRAY_SIZE(devices));
+	return 0;
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/Makefile linux-linaro-3.4-2012.05-1_cavium/arch/arm/Makefile
--- linux-linaro-3.4-2012.05-1_original/arch/arm/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -197,7 +197,7 @@
 machine-$(CONFIG_MACH_SPEAR320)		:= spear3xx
 machine-$(CONFIG_MACH_SPEAR600)		:= spear6xx
 machine-$(CONFIG_ARCH_ZYNQ)		:= zynq
-
+machine-$(CONFIG_ARCH_CELESTIAL)    := celestial
 # Platform directory name.  This list is sorted alphanumerically
 # by CONFIG_* macro name.
 plat-$(CONFIG_ARCH_MXC)		:= mxc
@@ -267,7 +267,8 @@
 KBUILD_IMAGE := zImage
 endif
 
-all:	$(KBUILD_IMAGE)
+all: $(KBUILD_IMAGE)
+	cp arch/arm/mach-celestial/cnc19xx_mem_info.o  $(CNC_PLATFORM)/configs/cnc19xx_$(CUSTOMER_NAME)_mem_info.o
 
 boot := arch/arm/boot
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mm/cache-l2x0.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mm/cache-l2x0.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mm/cache-l2x0.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mm/cache-l2x0.c	2014-07-29 17:28:38.819972000 +0800
@@ -23,6 +23,10 @@
 #include <linux/of.h>
 #include <linux/of_address.h>
 
+#ifdef CONFIG_SW_SUPPORT
+#include <mach/smc.h>
+#endif
+
 #include <asm/cacheflush.h>
 #include <asm/hardware/cache-l2x0.h>
 
@@ -353,6 +357,9 @@
 {
 	u32 aux;
 	u32 way_size = 0;
+#ifdef CONFIG_SW_SUPPORT
+	u32 pctrl, val;
+#endif
 	const char *type;
 
 	l2x0_base = base;
@@ -402,6 +409,21 @@
 	l2x0_size = l2x0_ways * way_size;
 	l2x0_sets = way_size / CACHE_LINE_SIZE;
 
+#ifdef CONFIG_SW_SUPPORT /* Sierraware Tzone support */
+	pctrl = readl(l2x0_base + L2X0_POWER_CTRL); //read power control register of L2 cache
+	pctrl = pctrl | 0x3;                         //prepare data
+
+	aux &= aux_mask;
+	aux |= aux_val;
+
+	/* SETUP2: arg1 - power ctrl, arg2 - aux ctrl, 
+	 *  arg3 - aux mask  
+	 */
+	sw_smc(SMC_CMD_L2X0SETUP1, pctrl, aux, aux_mask);
+
+	/* Init and Enable L2 cache */
+	sw_smc(SMC_CMD_L2X0CTRL, 1, 0, 0);
+#else
 	/*
 	 * Check if l2x0 controller is already enabled.
 	 * If you are booting from non-secure mode
@@ -424,7 +446,7 @@
 		/* enable L2X0 */
 		writel_relaxed(1, l2x0_base + L2X0_CTRL);
 	}
-
+#endif
 	outer_cache.inv_range = l2x0_inv_range;
 	outer_cache.clean_range = l2x0_clean_range;
 	outer_cache.flush_range = l2x0_flush_range;
@@ -432,7 +454,10 @@
 	outer_cache.flush_all = l2x0_flush_all;
 	outer_cache.inv_all = l2x0_inv_all;
 	outer_cache.disable = l2x0_disable;
-
+#ifdef CONFIG_SW_SUPPORT
+	val = readl_relaxed(l2x0_base + L2X0_CTRL);
+	pr_err("<<>>l2x0: l2x0 ctrl = %d\n", val);
+#endif
 	printk(KERN_INFO "%s cache controller enabled\n", type);
 	printk(KERN_INFO "l2x0: %d ways, CACHE_ID 0x%08x, AUX_CTRL 0x%08x, Cache size: %d B\n",
 			l2x0_ways, l2x0_cache_id, aux, l2x0_size);
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mm/Kconfig linux-linaro-3.4-2012.05-1_cavium/arch/arm/mm/Kconfig
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mm/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mm/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -883,7 +883,6 @@
 
 config ARM_L1_CACHE_SHIFT_6
 	bool
-	default y if CPU_V7
 	help
 	  Setting ARM L1 cache line size to 64 Bytes.
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mm/proc-v7.S linux-linaro-3.4-2012.05-1_cavium/arch/arm/mm/proc-v7.S
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mm/proc-v7.S	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mm/proc-v7.S	2014-07-29 17:28:38.819972000 +0800
@@ -243,6 +243,13 @@
 	mcrlt	p15, 0, r10, c15, c0, 1		@ write diagnostic register
 1:
 #endif
+	
+#ifndef CONFIG_SW_SUPPORT /* Sierraware Trustzone */
+	@enable high-level clock gating of cortex-a9	
+	mrc p15, 0, r10, c15, c0, 0  	@read power control register	
+	orr r10, r10, #1             	@prepare data
+	mcr p15, 0, r10, c15, c0, 0  	@write power control register
+#endif
 
 3:	mov	r10, #0
 	mcr	p15, 0, r10, c7, c5, 0		@ I+BTB cache invalidate
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/tools/mach-types linux-linaro-3.4-2012.05-1_cavium/arch/arm/tools/mach-types
--- linux-linaro-3.4-2012.05-1_original/arch/arm/tools/mach-types	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/tools/mach-types	2014-07-29 17:28:38.819972000 +0800
@@ -289,6 +289,7 @@
 trizeps4wl		MACH_TRIZEPS4WL		TRIZEPS4WL		1649
 ts78xx			MACH_TS78XX		TS78XX			1652
 sffsdr			MACH_SFFSDR		SFFSDR			1657
+celestial	    MACH_CELESTIAL	    CELESTIAL 		1662
 pcm037			MACH_PCM037		PCM037			1673
 db88f6281_bp		MACH_DB88F6281_BP	DB88F6281_BP		1680
 rd88f6192_nas		MACH_RD88F6192_NAS	RD88F6192_NAS		1681
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/build.sh linux-linaro-3.4-2012.05-1_cavium/build.sh
--- linux-linaro-3.4-2012.05-1_original/build.sh	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/build.sh	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,16 @@
+if [ -z "$CNC_PLATFORM" ]; then
+echo "*** ERROR: ${CNC_PLATFORM} is not a directory"
+exit
+fi	
+
+cp ${CNC_PLATFORM}/configs/kernel_config arch/arm/configs/cnc83xx_temp_defconfig
+make distclean;
+make cnc83xx_temp_defconfig
+make uImage -j24
+cp ./arch/arm/boot/uImage ${CNC_PLATFORM}/images
+UpdateVersionInfo.sh ${CNC_PLATFORM}/images/version.info uImage	${PWD}
+
+cnc_mem_info ./arch/arm/mach-celestial/cnc19xx_mem_info.o     ${CNC_PLATFORM}/configs/cnc19xx_${CUSTOMER_NAME}_mem_info.inc
+cat ${CNC_PLATFORM}/configs/cnc19xx_${CUSTOMER_NAME}_mem_info.inc
+UpdateVersionInfo.sh ${CNC_PLATFORM}/configs/version.info cnc19xx_${CUSTOMER_NAME}_mem_info.inc	${PWD}
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/debian/commit-templates/bumpabi linux-linaro-3.4-2012.05-1_cavium/debian/commit-templates/bumpabi
--- linux-linaro-3.4-2012.05-1_original/drivers/base/core.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/base/core.c	2015-04-21 14:24:43.374116000 +0800
@@ -190,10 +190,10 @@
 		dev->type->release(dev);
 	else if (dev->class && dev->class->dev_release)
 		dev->class->dev_release(dev);
-	else
+	/*else
 		WARN(1, KERN_ERR "Device '%s' does not have a release() "
 			"function, it is broken and must be fixed.\n",
-			dev_name(dev));
+			dev_name(dev));*/
 	kfree(p);
 }
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/base/firmware_class.c linux-linaro-3.4-2012.05-1_cavium/drivers/base/firmware_class.c
--- linux-linaro-3.4-2012.05-1_original/drivers/base/firmware_class.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/base/firmware_class.c	2014-07-29 17:28:38.819972000 +0800
@@ -80,7 +80,7 @@
 	FW_STATUS_ABORT,
 };
 
-static int loading_timeout = 60;	/* In seconds */
+static int loading_timeout = 1;	/* In seconds */
 
 static inline long firmware_loading_timeout(void)
 {
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/audio_reg_def.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/audio_reg_def.h
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/audio_reg_def.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/audio_reg_def.h	2014-08-13 14:09:14.922849000 +0800
@@ -0,0 +1,193 @@
+#ifndef __AUDIO_REG_DEF_H__
+#define __AUDIO_REG_DEF_H__
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define CSM_AUDIO_REG_BASE	(0xB1200000)
+#define CSM_AUDIO_REG_SIZE		(0x100000)
+
+/* ----------------- Common Register ------------------ */
+#define CSM1800_AUD_STC             (CSM_AUDIO_REG_BASE + 0x0000)
+#define CSM1800_AUD_HISTC           (CSM_AUDIO_REG_BASE + 0x0004)
+#define CSM1800_AUD_MAILBOX0        (CSM_AUDIO_REG_BASE + 0x0100)
+#define CSM1800_AUD_MAILBOX1        (CSM_AUDIO_REG_BASE + 0x0104)
+#define CSM1800_AUD_MAILBOX2        (CSM_AUDIO_REG_BASE + 0x0108)
+#define CSM1800_AUD_MAILBOX3        (CSM_AUDIO_REG_BASE + 0x010c)
+#define CSM1800_AUD_MAILBOX4        (CSM_AUDIO_REG_BASE + 0x0110)
+#define CSM1800_AUD_MAILBOX5        (CSM_AUDIO_REG_BASE + 0x0114)
+#define CSM1800_AUD2VID_MAILBOX0    (CSM_AUDIO_REG_BASE + 0x0118)
+#define CSM1800_VID2AUD_MAILBOX0    (CSM_AUDIO_REG_BASE + 0x011c)
+#define CSM1800_AUD2VID_MAILBOX1    (CSM_AUDIO_REG_BASE + 0x0120)
+#define CSM1800_VID2AUD_MAILBOX1    (CSM_AUDIO_REG_BASE + 0x0124)
+#define CSM1800_AUD_INT             (CSM_AUDIO_REG_BASE + 0x0200)
+#define CSM1800_DSP_INT_SRC         (CSM_AUDIO_REG_BASE + 0x0204)
+#define CSM1800_DSP_INT_MASK        (CSM_AUDIO_REG_BASE + 0x0208)
+#define CSM1800_DSP_INT_INPUT_BIT   0x01
+#define CSM1800_DSP_INT_SFT_BIT     0x02
+#define CSM1800_DSP_INT_UART_BIT    0x04
+#define CSM1800_DSP_INT_TIMER0_BIT  0x08
+#define CSM1800_DSP_INT_TIMER1_BIT  0x10
+#define CSM1800_AUD_SRC_MIX_BOUND   (CSM_AUDIO_REG_BASE + 0x0500)
+#define CSM1800_AUD_DDR_IO          (CSM_AUDIO_REG_BASE + 0x0504)
+
+/* ------------------ I2s input ---------------------- */
+#define CSM1800_AUDIO_INPUT_LEVEL   (CSM_AUDIO_REG_BASE + 0x0300)
+#define CSM1800_AUDIO_INPUT_CTRL    (CSM_AUDIO_REG_BASE + 0x0304)
+#define CSM1800_AUDIO_INPUT_CTRL_ENABLE_BIT     0x1
+#define CSM1800_AUDIO_INPUT_CTRL_INVERT_WS_BIT  0x10
+#define CSM1800_AUDIO_INPUT_CTRL_INVERT_SCK_BIT 0x100
+#define CSM1800_AUDIO_INPUT_CTRL_SHIFT_CNT_BIT  0x1f0000
+
+#define CSM1800_AUDIO_INPUT_CNT     (CSM_AUDIO_REG_BASE + 0x0308)
+#define CSM1800_AUDIO_INPUT_SAMPLE  (CSM_AUDIO_REG_BASE + 0x030c)
+#define CSM1800_AUDIO_INPUT_RATE    (CSM_AUDIO_REG_BASE + 0x0310)
+
+#define CSM1800_AUD_PTS0RP          (CSM_AUDIO_REG_BASE + 0x0400)
+#define CSM1800_AUD_PTS0WP          (CSM_AUDIO_REG_BASE + 0x0404)
+#define CSM1800_AUD_PTS0UP          (CSM_AUDIO_REG_BASE + 0x0408)
+#define CSM1800_AUD_PTS0LOW         (CSM_AUDIO_REG_BASE + 0x040c)
+#define CSM1800_AUD_PTS1RP          (CSM_AUDIO_REG_BASE + 0x0410)
+#define CSM1800_AUD_PTS1WP          (CSM_AUDIO_REG_BASE + 0x0414)
+#define CSM1800_AUD_PTS1UP          (CSM_AUDIO_REG_BASE + 0x0418)
+#define CSM1800_AUD_PTS1LOW         (CSM_AUDIO_REG_BASE + 0x041c)
+#define CSM1800_AUD_PTS_BITWIDTH    (0x0FFFFFF8)
+#define CSM1800_AUD_PTS_TOGGLEBIT   (0x10000000)
+
+/* ------------------ AUDIO I2S ----------------------- */
+#define CSM1800_AUD_I2S_SHIFTCNT    (CSM_AUDIO_REG_BASE + 0x1000)
+#define CSM1800_AUD_I2S_CNTL        (CSM_AUDIO_REG_BASE + 0x1004)
+#define CSM1800_AUD_I2S_RP0         (CSM_AUDIO_REG_BASE + 0x1100)
+#define CSM1800_AUD_I2S_WP0         (CSM_AUDIO_REG_BASE + 0x1104)
+#define CSM1800_AUD_I2S_UP0         (CSM_AUDIO_REG_BASE + 0x1108)
+#define CSM1800_AUD_I2S_LOW0        (CSM_AUDIO_REG_BASE + 0x110c)
+#define CSM1800_AUD_I2S_SCAL0       (CSM_AUDIO_REG_BASE + 0x1110)
+#define CSM1800_AUD_I2S_RP1         (CSM_AUDIO_REG_BASE + 0x1114)
+#define CSM1800_AUD_I2S_WP1         (CSM_AUDIO_REG_BASE + 0x1118)
+#define CSM1800_AUD_I2S_UP1         (CSM_AUDIO_REG_BASE + 0x111c)
+#define CSM1800_AUD_I2S_LOW1        (CSM_AUDIO_REG_BASE + 0x1120)
+#define CSM1800_AUD_I2S_SCAL1       (CSM_AUDIO_REG_BASE + 0x1124)
+#define CSM1800_AUD_I2S_BITWIDTH    0x7FFFFFF8
+#define CSM1800_AUD_I2S_TOGGLEBIT   0x80000000
+
+/* ------------------ AUDIO I2S ----------------------- */
+#define CSM1800_AUD_SPDIF_CNTL      (CSM_AUDIO_REG_BASE + 0x2000)
+#define CSM1800_AUD_SPDIF_RP0       (CSM_AUDIO_REG_BASE + 0x2100)
+#define CSM1800_AUD_SPDIF_WP0       (CSM_AUDIO_REG_BASE + 0x2104)
+#define CSM1800_AUD_SPDIF_UP0       (CSM_AUDIO_REG_BASE + 0x2108)
+#define CSM1800_AUD_SPDIF_LOW0      (CSM_AUDIO_REG_BASE + 0x210c)
+#define CSM1800_AUD_SPDIF_SCAL0     (CSM_AUDIO_REG_BASE + 0x2110)
+#define CSM1800_AUD_SPDIF_RP1       (CSM_AUDIO_REG_BASE + 0x2114)
+#define CSM1800_AUD_SPDIF_WP1       (CSM_AUDIO_REG_BASE + 0x2118)
+#define CSM1800_AUD_SPDIF_UP1       (CSM_AUDIO_REG_BASE + 0x211c)
+#define CSM1800_AUD_SPDIF_LOW1      (CSM_AUDIO_REG_BASE + 0x2120)
+#define CSM1800_AUD_SPDIF_SCAL1     (CSM_AUDIO_REG_BASE + 0x2124)
+#define CSM1800_AUD_SPDIF_VERSION   (CSM_AUDIO_REG_BASE + 0x2200)
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS1  (CSM_AUDIO_REG_BASE + 0x2204)
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS12 (CSM_AUDIO_REG_BASE + 0x2208)
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS2  (CSM_AUDIO_REG_BASE + 0x220c)
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS3  (CSM_AUDIO_REG_BASE + 0x2210) // Audio Bit Rate 
+#define CSM1800_AUD_SPDIF_VALID           (CSM_AUDIO_REG_BASE + 0x2238)
+#define CSM1800_AUD_SPDIF_FIFO_STATUS     (CSM_AUDIO_REG_BASE + 0x223c)
+#define CSM1800_AUD_SPDIF_BITWIDTH    0x7FFFFFF8
+#define CSM1800_AUD_SPDIF_TOGGLEBIT   0x80000000
+
+/* not used spdif regs */
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS4 (CSM_AUDIO_REG_BASE + 0x2214)
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS5 (CSM_AUDIO_REG_BASE + 0x2218)
+#define CSM1800_AUD_SPDIF_CHANNELSTATUS6 (CSM_AUDIO_REG_BASE + 0x221C)
+#define CSM1800_AUD_SPDIF_USERDATA1      (CSM_AUDIO_REG_BASE + 0x2220)
+#define CSM1800_AUD_SPDIF_USERDATA2      (CSM_AUDIO_REG_BASE + 0x2224)
+#define CSM1800_AUD_SPDIF_USERDATA3      (CSM_AUDIO_REG_BASE + 0x2228)
+#define CSM1800_AUD_SPDIF_USERDATA4      (CSM_AUDIO_REG_BASE + 0x222C)
+#define CSM1800_AUD_SPDIF_USERDATA5      (CSM_AUDIO_REG_BASE + 0x2230)
+#define CSM1800_AUD_SPDIF_USERDATA6      (CSM_AUDIO_REG_BASE + 0x2234)
+
+/* ------------------ AUDIO SRC ---------------------- */
+#define CSM1800_AUD_SRC_BASEADDR    (CSM_AUDIO_REG_BASE + 0x3000)
+#define CSM1800_AUD_SRC_BASEADDR_BITS 0x3FC00000 // b29:b22
+#define CSM1800_AUD_SRC_ADDRPARA    (CSM_AUDIO_REG_BASE + 0x3004)
+#define CSM1800_AUD_SRC_CONTROL     (CSM_AUDIO_REG_BASE + 0x3008)
+#define CSM1800_AUD_SRC_INWP        (CSM_AUDIO_REG_BASE + 0x3100) // 8 copy
+#define CSM1800_AUD_SRC_INRP        (CSM_AUDIO_REG_BASE + 0x3200) // 8 copy
+#define CSM1800_AUD_SRC_INLOW       (CSM_AUDIO_REG_BASE + 0x3300) // 8 copy
+#define CSM1800_AUD_SRC_INUP        (CSM_AUDIO_REG_BASE + 0x3400) // 8 copy
+#define CSM1800_AUD_SRC_OUTWP       (CSM_AUDIO_REG_BASE + 0x3500) // 8 copy
+#define CSM1800_AUD_SRC_OUTRP       (CSM_AUDIO_REG_BASE + 0x3600) // 8 copy
+#define CSM1800_AUD_SRC_OUTLOW      (CSM_AUDIO_REG_BASE + 0x3700) // 8 copy
+#define CSM1800_AUD_SRC_OUTUP       (CSM_AUDIO_REG_BASE + 0x3800) // 8 copy
+#define CSM1800_AUD_SRC_INFRLTH     (CSM_AUDIO_REG_BASE + 0x3900) // 8 copy
+#define CSM1800_AUD_SRC_OUTFRLTH    (CSM_AUDIO_REG_BASE + 0x3a00) // 8 copy
+#define CSM1800_AUD_SRC_BITWIDTH    (0x3ffff8)
+#define CSM1800_AUD_SRC_TOGGLEBIT   (0x400000)
+
+/* -----------------AUDIO DAC ------------------------ */
+#define CSM_AUDIO_DAC_REG_BASE (CSM_AUDIO_REG_BASE + 0x8000)
+#define CNC1900_AUD_DAC_RESET_ADDR (CSM_AUDIO_DAC_REG_BASE+0x0)
+#define CNC1900_AUD_DAC_LATCH_ADDR (CSM_AUDIO_DAC_REG_BASE+(0x1<<2))
+#define CNC1900_AUD_DAC_I2SMSMODE_ADDR (CSM_AUDIO_DAC_REG_BASE+(0xe<<2))
+#define CNC1900_AUD_DAC_POWER_CONTROL3_ADDR (CSM_AUDIO_DAC_REG_BASE+(0x18<<2))
+#define CNC1900_AUD_DAC_POWER_CONTROL0_ADDR (CSM_AUDIO_DAC_REG_BASE+(0x15<<2))
+#define CNC1900_AUD_DAC_POP_SUPPRESSION_1 (CSM_AUDIO_DAC_REG_BASE+(0xA2<<2))
+#define CNC1900_AUD_DAC_POP_SUPPRESSION_2 (CSM_AUDIO_DAC_REG_BASE+(0xA3<<2))
+#define CNC1900_AUD_DAC_POP_SUPPRESSION_SEG_START (CSM_AUDIO_DAC_REG_BASE+(0xA4<<2))
+#define CNC1900_AUD_DAC_POWER_CONSUMPTION (CSM_AUDIO_DAC_REG_BASE+(0x12<<2))
+#define CNC1900_AUD_DAC_SLEEPMODE    (CSM_AUDIO_DAC_REG_BASE + (0x11<<2))
+
+/* ------------------ INPUT FIFO --------------------- */
+#define CSM1800_AUD_CAB0RP          (CSM_AUDIO_REG_BASE + 0x4100)
+#define CSM1800_AUD_CAB0WP          (CSM_AUDIO_REG_BASE + 0x4104)
+#define CSM1800_AUD_CAB0UP          (CSM_AUDIO_REG_BASE + 0x4108)
+#define CSM1800_AUD_CAB0LOW         (CSM_AUDIO_REG_BASE + 0x410c)
+#define CSM1800_AUD_IFIFO0          (CSM_AUDIO_REG_BASE + 0x4110)
+#define CSM1800_AUD_CAB1RP          (CSM_AUDIO_REG_BASE + 0x4200)
+#define CSM1800_AUD_CAB1WP          (CSM_AUDIO_REG_BASE + 0x4204)
+#define CSM1800_AUD_CAB1UP          (CSM_AUDIO_REG_BASE + 0x4208)
+#define CSM1800_AUD_CAB1LOW         (CSM_AUDIO_REG_BASE + 0x420c)
+#define CSM1800_AUD_CAB_BITWIDTH    (0x7FFFFFFF)
+#define CSM1800_AUD_CAB_TOGGLEBIT   (0x80000000)
+
+#define CSM1800_AUD_IFIFO1          (CSM_AUDIO_REG_BASE + 0x4210)
+#define CSM1800_AUD_IFIFO_CTRL      (CSM_AUDIO_REG_BASE + 0x4000)
+#define CSM1800_AUD_IFIFO_CTRL_ENABLE0 0x1
+#define CSM1800_AUD_IFIFO_CTRL_ENABLE1 0x2
+#define CSM1800_AUD_IFIFO_CTRL_CLEAR0  0x4 // disable first, then clear
+#define CSM1800_AUD_IFIFO_CTRL_CLEAR1  0x8
+#define CSM1800_AUD_IFIFOCNT        (CSM_AUDIO_REG_BASE + 0x4004)
+                                    // high 16 bits for fifo1,
+                                    // low 16 bits for fifo0.
+                                    
+/* ------------------ Audio DMA -------------------------- */
+#define CSM1800_AUD_DMA_REG_BASE    (0xB1230000)
+#define CSM1800_AUD_DMA_SDRAM_BASE  (CSM1800_AUD_DMA_REG_BASE + 0xc000)
+#define CSM1800_AUD_DMA_LEN         (CSM1800_AUD_DMA_REG_BASE + 0xc004)
+#define CSM1800_AUD_DMA_CTRL        (CSM1800_AUD_DMA_REG_BASE + 0xc008)
+#define CSM1800_AUD_DMA_STATUS      (CSM1800_AUD_DMA_REG_BASE + 0xc00c)    
+#define CSM1800_AUD_DMA_SRAM0_BASE  (CSM1800_AUD_DMA_REG_BASE + 0xe000)
+#define CSM1800_AUD_DMA_SRAM1_BASE  (CSM1800_AUD_DMA_REG_BASE + 0xf000)
+
+/* --------------- RISC CPU control ------------------ */
+#define CSM1800_AUDIO_RISC_CTRL     (0xB1230000)
+#define CSM1800_RISC_IO_PROT        (0xB1230004)
+
+/* ------------------ Code & Data ------------------------ */
+#define CSM1800_AUD_ICACHE_BASE     (0xB1210000)
+#define CSM1800_AUD_DSRAM_BASE      (0xB1220000)
+
+/* ------------------ Assistant registers ------------- */
+#define REGPACK_REGBASE 0xB1400000
+#define XPORT_CAB0_WP               (REGPACK_REGBASE+0x0410)
+#define XPORT_CAB1_WP               (REGPACK_REGBASE+0x0418)
+#define CSM1800_XPORT_CAB_TOGGLEBIT (0x80000000)
+
+#define ID_SCS_BASE                 (0xB2100000)
+#define ID_SCS_SOFT_RESET           (ID_SCS_BASE + 0x200)
+#define Audio_rst_bit               0x8
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/audio/cnc1900_audio.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/audio/cnc1900_audio.c
